const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const messages = sequelize.define(
    'messages',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

message_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"text",


"image",


"file",


"system"

        ],

      },

body: {
        type: DataTypes.TEXT,
      
      

      },

sent_at: {
        type: DataTypes.DATE,
      
      

      },

delivered_at: {
        type: DataTypes.DATE,
      
      

      },

read_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  messages.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
























    db.messages.hasMany(db.content_moderation_items, {
      as: 'content_moderation_items_message',
      foreignKey: {
          name: 'messageId',
      },
      constraints: false,
    });





//end loop



    db.messages.belongsTo(db.matches, {
      as: 'match',
      foreignKey: {
        name: 'matchId',
      },
      constraints: false,
    });

    db.messages.belongsTo(db.users, {
      as: 'sender',
      foreignKey: {
        name: 'senderId',
      },
      constraints: false,
    });



    db.messages.hasMany(db.file, {
      as: 'image',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.messages.getTableName(),
        belongsToColumn: 'image',
      },
    });

    db.messages.hasMany(db.file, {
      as: 'attachment',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.messages.getTableName(),
        belongsToColumn: 'attachment',
      },
    });


    db.messages.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.messages.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return messages;
};


